import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.*;
import java.applet.Applet;

public class Style extends Applet {
	Canvas drawArea;
	Button reset;
	Button soundbut;
	Button conbut;
	Button xdata;
	Label conLabel;
	dataWindow dwind;
	Image eurimage;
	int curx,cury;
	int targx,targy;

	String shostname;
	int is_connected = 0;
	int is_firsttime = 1;
	int is_sound = 0;

	Socket sendSocket;
	DataOutputStream sockout;

//	private static Color fg = new Color((float)0.7, (float)0.8, (float)1.0);
	private static Color fg = new Color((float)0.56, (float)0.94, (float)1.0);

	public void init() {
		curx = 408;
		targx = 408;
		cury = 340;
		targy = 340;

		this.setBackground(fg);

		//Add Components to the Applet.
		GridBagLayout gridBag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridBag);


		drawArea = new Canvas();
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.fill = GridBagConstraints.BOTH;
		c.gridheight = 4;
		c.weightx = 1.0;
		c.weighty = 1.0;
		gridBag.setConstraints(drawArea, c);
		drawArea.setBackground(fg);
		add(drawArea);


		reset = new Button("reset");
		c.gridwidth = 1;
		c.weightx = 0.0;
		c.weighty = 0.0;
		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(reset, c);
		reset.setBackground(fg.lightGray);
		add(reset);

		soundbut = new Button("stop  sound");
		c.gridwidth = 1;
		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.CENTER;
		gridBag.setConstraints(soundbut, c);
		soundbut.setBackground(fg.lightGray);
		soundbut.disable();
		add(soundbut);

		xdata = new Button("additional parameters");
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.fill = GridBagConstraints.NONE;
		c.anchor = GridBagConstraints.EAST;
		gridBag.setConstraints(xdata, c);
		xdata.setBackground(fg.lightGray);
		add(xdata);

		conbut = new Button("  connect  ");
		c.gridwidth = 1;
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(conbut, c);
		conbut.setBackground(fg.lightGray);
		conbut.disable();
		add(conbut);

		conLabel = new Label("not connected...");
		c.fill = GridBagConstraints.BOTH;
		c.gridwidth = GridBagConstraints.REMAINDER;
		c.weightx = 1.0;
		c.anchor = GridBagConstraints.EAST;
		gridBag.setConstraints(conLabel, c);
		add(conLabel);

		validate();

		eurimage = getImage(getCodeBase(), "europe.gif");
		drawArea.getGraphics().drawImage(eurimage, 0, 0, this);
	}

	public boolean action(Event e, Object arg) {
		Object target = e.target;
		Graphics dg;
		int ival;

		if (target == reset) {
			dg = drawArea.getGraphics();
			dg.drawImage(eurimage, 0, 0, this);
			repaint();
			}

		if (target == soundbut) {
			if (is_sound == 1) {
				try {
					ival = 888;
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.flush();
				} catch (IOException ex) {
					System.err.println("Couldn't write them bytes\n");
				}
				soundbut.setLabel("start sound");
				is_sound = 0;
			}
			else {
				try {
					ival = 777;
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.flush();
				} catch (IOException ex) {
					System.err.println("Couldn't write them bytes\n");
				}
				soundbut.setLabel("stop  sound");
				is_sound = 1;
			}
		}

		if (target == xdata) {
			if (dwind == null) {
				dwind = new dataWindow(this, "Additional Parameters");
			}
			dwind.show();
		}

		if (target == conbut) {
			if (is_connected == 0) {
				try {
					sendSocket = new Socket(shostname, 2102);
					sockout = new DataOutputStream(sendSocket.getOutputStream());
					conLabel.setText("connected!");
					is_connected = 1;
					conbut.setLabel("disconnect");
				} catch (UnknownHostException ex) {
					System.err.println("problem connecting to host\n");
					System.exit(1);
				} catch (IOException ex) {
					System.err.println("Couldn't get I/O for the connection\n");
					System.exit(1);
				}
			}
			else {
				try {
					ival = 999;
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.flush();
					sockout.close();
					sendSocket.close();
				} catch (IOException ex) {
					System.err.println("Couldn't close the socket!");
				}
				conLabel.setText("not connected...");
				conbut.setLabel("  connect  ");
				is_connected = 0;
			}
		}

		return true;
	}

	public boolean mouseDown(Event event, int x, int y) {
		int ival;
		if (is_connected == 1) {
			if (is_firsttime == 1) {
				soundbut.enable();
				ival = 777;
				try {
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.flush();
				} catch (IOException ex) {
					System.err.println("Couldn't write them bytes\n");
				}
				is_firsttime = 0;
				is_sound = 1;
			}
		}

		targx = x;
		targy = y;

		repaint();

		drawpath();

		return true;
	}


	public void paint(Graphics g) {
		Graphics dg;

		dg = drawArea.getGraphics();

		dg.setColor(fg.black);
		dg.fillOval(curx,cury,5,5);
		dg.setColor(fg.red);
		dg.fillOval(targx,targy,5,5);
	}

	public void drawpath() {
		Graphics dg;
		double distance;
		int i,nsteps;
		double xincr,yincr;
		double dtx,dty;
		double pxval,pyval;
		double probEast;
		double probSouth;
		double dice;
		int ival;
		Random rgen = new Random();

		dg = drawArea.getGraphics();

		distance = java.lang.Math.sqrt(((double)(targx-curx)*(double)(targx-curx)) +
						((double)(targy-cury)*(double)(targy-cury)));
		nsteps = (int)(distance/10.0);
		xincr = (double)((targx+2)-(curx+2))/(double)nsteps;
		yincr = (double)((targy+2)-(cury+2))/(double)nsteps;
		dtx = (double)(curx+2);
		dty = (double)(cury+2);
		nsteps /= 2;
		for (i = 0; i < nsteps-1; i++) {
			dg.setColor(fg.red);
			dtx = dtx + (2.0*xincr);
			dty = dty + (2.0*yincr);
			dg.drawLine((int)dtx,(int)dty, (int)(dtx+xincr), (int)(dty+yincr));
			try {
				java.lang.Thread.sleep(700);
				repaint();
			} catch (InterruptedException ex) {
				System.err.println("I gots interrupted...");
			}
			if (is_connected == 1) {
				pxval = dtx - 70.0;
				if (pxval < 0.0) pxval = 0.0;
				probEast = pxval/430.0;

				pyval = dty - 100.0;
				if (pyval < 0.0) pyval = 0.0;
				probSouth = pyval/250.0;

				dice = rgen.nextDouble();
				if (probEast > dice) {
					dice = rgen.nextDouble();
					if (probSouth > dice) ival = 2; // "greek"
					else ival = 4; // "northern"
				}
				else {
					dice = rgen.nextDouble();
					if (probSouth > dice) ival = 3; // "african"
					else ival = 1; // "irish"
				} 
				if ( ((dtx > 60.0) && (dtx < 106.0)) && ((dty > 115.0) && (dty < 202.0)) ) ival = 1; // "irish" for sure
				if ( ((dtx > 84.0) && (dtx < 199.0)) && ((dty > 303.0) && (dty < 342.0)) ) ival = 3; // "african" for sure
				if ( ((dtx > 294.0) && (dtx < 465.0)) && ((dty > 283.0) && (dty < 344.0)) ) ival = 2; // "greek" for sure
				if ( ((dtx > 316.0) && (dtx < 445.0)) && ((dty > 37.0) && (dty < 151.0)) ) ival = 4; // "northern" for sure
				if ( ((dtx > 179.0) && (dtx < 309.0)) && ((dty > 160.0) && (dty < 250.0)) ) ival = 5; // "german" for sure
				try {
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.writeInt(ival);
					sockout.flush();
				} catch (IOException ex) {
					System.err.println("Couldn't write them bytes\n");
				}
			}
		}
		curx = targx;
		cury = targy;
	}
}


class dataWindow extends Frame {
	TextField hnameField;
	Label hnameLabel;
	Style St;
	Button done;

	dataWindow(Style caller, String title) {
		super(title);
		St = caller;

		GridBagLayout gridBag = new GridBagLayout();
		GridBagConstraints c = new GridBagConstraints();
		setLayout(gridBag);


		hnameLabel = new Label("Enter RTcmix/sound server name:");
		c.anchor = GridBagConstraints.EAST;
		c.gridwidth = 1;
		gridBag.setConstraints(hnameLabel, c);
		add(hnameLabel);

		hnameField = new TextField(50);
		c.gridwidth = GridBagConstraints.REMAINDER; //end of row
		c.anchor = GridBagConstraints.WEST;
		gridBag.setConstraints(hnameField, c);
		add(hnameField);


		done = new Button("done");
		c.gridwidth = 1;
		c.anchor = GridBagConstraints.CENTER;
		gridBag.setConstraints(done, c);
		add(done);

		pack();
	}

	public boolean action(Event e, Object arg) {
		Object target = e.target;

		if (target == hnameField) {
			St.shostname = hnameField.getText();
			St.conbut.enable();
		}

		if (target == done) {
			hide();
		}
		return true;
	}
}

