; ok, here's the organiztion:
;   The flute will look to a list of encapsulated "gestures"
;   for the data.  Each "gesture" will contain appropriate
;   RHYTHM, PITCH and INFLECTION lists.
; added "length" property for the irish stuff -- BGG 2/98

; set up the rhythms

(setq e 0.07)
(setq q (* e 2))
(setq dq (+ q e))
(setq h (* q 2))
(setq w (* h 2))
(setq lq (* w 2))
(setq lh (* lq 2))
(setq lw (* lh 2))

; and here is the list of pitches to be parsed for lengths
; later each of these may be a list of lists with several
; combinations for each pitch possible

(setq g7   '(112 25))
(setq ab7  '(106 24))
(setq a7   '(100 19))
(setq bb7  '(95 21))
(setq b7   '(89 19))
(setq c8   '(84 18))
(setq db8  '(79 23))
(setq d8   '(75 19))
(setq eb8  '(70 15))
(setq e8   '(67 16))
(setq f8   '(63 19))
(setq gb8  '(59 17))
(setq g8   '(56 17))
(setq ab8  '(53 25))
(setq a8   '(50 16))
(setq bb8  '(47 12))
(setq b8   '(44 11))
(setq c9   '(42 10))
(setq db9  '(39 10))
(setq d9   '(37 8))
(setq eb9  '(35 9))
(setq e9   '(33 18))
(setq f9   '(31 18))
(setq gb9  '(29 39))
(setq g9   '(28 14))
(setq ab9  '(26 15))
(setq a9   '(24 17))
(setq bb9  '(23 14))
(setq b9   '(22 34))
(setq c10  '(21 9))

; gest0
(put 'gest0 'rhys '(h))
(put 'gest0 'pches '(a8))
(put 'gest0 'flects '(lblow lblow lblow lblow))
(put 'gest0 'length 4))


; irish ones

; gest1
(put 'gest1 'rhys '(dq e))
(put 'gest1 'pches '(a8 d8 e8 d8))
(put 'gest1 'flects '(lblow lblow lblow lblow))
(put 'gest1 'length 4))

; gest2
(put 'gest2 'rhys '(dq e))
(put 'gest2 'pches '(c8 d8 c8 a7))
(put 'gest2 'flects '(lblow lblow lblow lblow))
(put 'gest2 'length 4))

; gest3
(put 'gest3 'rhys '(dq e))
(put 'gest3 'pches '(d8 e8 d8 c8))
(put 'gest3 'flects '(lblow lblow lblow lblow))
(put 'gest3 'length 4))

; gest4
(put 'gest4 'rhys '(dq e))
(put 'gest4 'pches '(d8 a8 a8 d8))
(put 'gest4 'flects '(lblow lblow lblow lblow))
(put 'gest4 'length 4))


; unknown

; gest5
(put 'gest5 'rhys '(e q))
(put 'gest5 'pches '(a8 gb8))
(put 'gest5 'flects '(bend blow))
(put 'gest5 'length 2))

; gest6 
(put 'gest6 'rhys '(e e e e e e))
(put 'gest6 'pches '(a8 gb8 a8 a8 a8))
(put 'gest6 'flects '(blow bend blow blow blow))
(put 'gest6 'length 5))

; gest7 
(put 'gest7 'rhys '(e e q e e))
(put 'gest7 'pches '(a8 f8 a8))
(put 'gest7 'flects '(bend))
(put 'gest7 'length 8))

; gest8
(put 'gest8 'rhys '(e w))
(put 'gest8 'pches '(f8 c9 a8))
(put 'gest8 'flects '(blow blow blow bend))
(put 'gest8 'length 7))


; greek ones

; gest9
(put 'gest9 'rhys '(h w h lq h))
(put 'gest9 'pches '(d8 g8))
(put 'gest9 'flects '(blow blow blow vib rest))
(put 'gest9 'length 5)

; gest10
(put 'gest10 'rhys '(lq))
(put 'gest10 'pches '(a8))
(put 'gest10 'flects '(trill))
(put 'gest10 'length 1)

; gest11
(put 'gest11 'rhys '(w w w))
(put 'gest11 'pches '(a8 b8 a8))
(put 'gest11 'flects '(trill))
(put 'gest11 'length 4)

; gest12
(put 'gest12 'rhys '(q q q q q q lq w))
(put 'gest12 'pches '(g8 a8 d9 e9 d9 a8 g8))
(put 'gest12 'flects '(lblow lblow lblow lblow lblow lblow vib rest))
(put 'gest12 'length 8)

; gest13
(put 'gest13 'rhys '(lq h))
(put 'gest13 'pches '(bb8))
(put 'gest13 'flects '(vib rest))
(put 'gest13 'length 2)

; gest14
(put 'gest14 'rhys '(h h h h lq))
(put 'gest14 'pches '(g8 f8 d8 c8 c8))
(put 'gest14 'flects '(blow trill blow rest vib))
(put 'gest14 'length 5)

; gest15
(put 'gest15 'rhys '(h h h h h h))
(put 'gest15 'pches '(g8 f8 a8 a8 a8))
(put 'gest15 'flects '(blow trill blow blow blow))
(put 'gest15 'length 5)


; "african" ones

; gest16
(put 'gest16 'rhys '(h h h h h h))
(put 'gest16 'pches '(a8 e9 bb8))
(put 'gest16 'flects '(blow rest blow rest trill rest))
(put 'gest16 'length 6)

; gest17
(put 'gest17 'rhys '(q q q))
(put 'gest17 'pches '(e9 eb9 e9))
(put 'gest17 'flects '(blow blow blow rest))
(put 'gest17 'length 4)

; gest18
(put 'gest18 'rhys '(q q q))
(put 'gest18 'pches '(a9))
(put 'gest18 'flects '(blow rest trill rest blow rest))
(put 'gest18 'length 6)


; "northern" ones

; gest19
(put 'gest19 'rhys '(lw lq))
(put 'gest19 'pches '(a7))
(put 'gest19 'flects '(bend rest))
(put 'gest19 'length 2) 

; gest20
(put 'gest20 'rhys '(lh w))
(put 'gest20 'pches '(c8))
(put 'gest20 'flects '(bvib rest))
(put 'gest20 'length 2) 

; gest21
(put 'gest21 'rhys '(lw lq))
(put 'gest21 'pches '(g7))
(put 'gest21 'flects '(bbend rest))
(put 'gest21 'length 2) 

; gest22
(put 'gest22 'rhys '(lq lq lh lq))
(put 'gest22 'pches '(d8 g8 c8))
(put 'gest22 'flects '(bend bvib bbend rest))
(put 'gest22 'length 4) 

; "german" ones

; gest23
(put 'gest23 'rhys '(q q q q))
(put 'gest23 'pches '(a8 a8 a8 a8 db9 db9 db9 db9))
(put 'gest23 'flects '(blow rest))
(put 'gest23 'length 8)

; gest24
(put 'gest24 'rhys '(q q q q))
(put 'gest24 'pches '(d9 d9 d9 d9 b8 b8 b8 b8))
(put 'gest24 'flects '(blow rest))
(put 'gest24 'length 8)

; gest25
(put 'gest25 'rhys '(q q q q))
(put 'gest25 'pches '(e9 e9 e9 e9 db9 db9 db9 db9))
(put 'gest25 'flects '(blow rest))
(put 'gest25 'length 8)


;(setq GESTURES '(gest0))
;(setq GESTURES '(gest1 gest2 gest3 gest4 gest5 gest6 gest7 gest8))
;(setq GESTURES '(gest8))

(setq IGESTURES '(gest1 gest2 gest3 gest4))
(setq GGESTURES '(gest9 gest10 gest11 gest12 gest13 gest14 gest15))
(setq AGESTURES '(gest16 gest17 gest18))
(setq NGESTURES '(gest19 gest20 gest21 gest22))
(setq DGESTURES '(gest23 gest24 gest25))

(setq GESTURES GGESTURES)
